/*
 * iGeom by LInE
 * Free software to student private data
 *
 * http://www.matematica.br/igeom
 * http://www.usp.br/line
 *
 * Create and register new element MidPoint
 * It is used in ./app/core/application/menu.js
 *
 * ./app/component-registry/middle-point-component.js
 * @version 2023/09/20: Added new parameter 'description,' to 'ComponentOptions'
 */

import { MiddlePointDrawer } from "../components/middle-point/drawers/middle-point-drawer";
import { Component } from "../core/models/components/component";
import { ComponentOptions } from "../core/models/components/component-options";

class MiddlePointComponent extends Component {

  //TODO: it is necessary internationalization!

  constructor () {
    const options = new ComponentOptions(
      "ccaa4bb8-f7ba-432e-94d2-07d9c5812ac3",
      "Middle Point",
      "Create the MidPoint of two given points (select those 2 points)",
      "middle-point"
      );
    super(new MiddlePointDrawer(), options);
    }
  }

export const middlePointComponent = new MiddlePointComponent();